package require MODDBC
package provide MODDBC_Sybase 1.0

proc syb_initcmd {} {
  package require Sybtcl
}

proc syb_destroycmd {} {
  package forget Sybtcl
}

proc syb_connectcmd {db_name host port user password} {
  set handle [sybconnect $user $password $host]
  sybuse $handle $db_name
  return $handle
}

proc syb_disconnectcmd {handle} {
  sybclose $handle
}

proc syb_sqlcmd {handle cmd} {
  sybsql $handle $cmd
}

proc syb_nextcmd {handle} {
  sybnext $handle
}

proc syb_colnamecmd {handle} {
  sybcols $handle
}

proc syb_coltypecmd {handle} {
  return $::sybmsg(coltypes)
}

proc syb_colsizecmd {handle} {
  return $::sybmsg(collengths)
}

db_register sybase syb_initcmd syb_destroycmd syb_connectcmd \
            syb_disconnectcmd syb_sqlcmd syb_nextcmd syb_colnamecmd \
            syb_coltypecmd syb_colsizecmd
